#!/usr/bin/perl -w
use strict;
#use lib qw( @@ LIBDIR@@ );
use lib qw( /usr/share/perl5/vendor_perl/ );
# my $kas=/"/";

use RRDs;
use CGI qw (:standard);
use CGI::Carp qw (fatalsToBrowser croak );
use Plugins;
use Misc;
use Misc qw ( OpenUserConfig SaveUserConfig GetClassesNames $valid_langs Initialize_configs );

$ENV{'PATH'} = '/bin:/usr/bin:/sbin:/usr/sbin';

#limit size data form
$CGI::POST_MAX = 3000;
$CGI::DISABLE_UPLOADS = 1;

Initialize_configs () if (exists ($ENV{'MOD_PERL'})); #check and reinitialize config files for mod_perl

use vars qw ( %Tags );  #table ob tags
LoadLangData ('', 'edit'); #load info about edit parameters

my $charset = $dict {'CHARSET'}; #use correct charset
my $customname = 'custom'; #name custom page
$Tags {'PNG_URL'} = $sysconfig  {'PNG_URL'};
$Tags {'PNG_DIR'} = $sysconfig {'PNG_DIR'};
$Tags {'DOC_URL'} = $tempconfig {'DOC'};
$Tags {'DOC_ROOT'} = $sysconfig {'DOC_URL'};
$Tags {'ICONS'} = $sysconfig {'ICONS'};
$Tags {'IMG'} = $tempconfig {'IMG'};
$Tags {'LANG_IMG'} = $tempconfig {'LANG_IMG'};

$tempconfig {'SCRIPT_URL' } = "./".url (-relative=>1);   #save script URL

$Tags {'SCRIPT_URL' } = $tempconfig {'SCRIPT_URL' };
my $scripturl2 = self_url ();
$Tags {'SELF_URL'} =$scripturl2;

my $DefaultTemplate = "emain.html";
if  (param ('template')) {
 $DefaultTemplate = param ('template');
}

#test lock
if ( -e $sysconfig {'LSTAT_LCK'}) {
 $Tags{'LOCK_FILE'} = $sysconfig {'LSTAT_LCK'};
 $DefaultTemplate = "locked.html";
 print header (-expires=>'now',-charset=>$charset);
 #generate HTML page from template
 Gen (\%Tags,$DefaultTemplate,1);
 exit
}


#catch results of forms
my $Result=0;
if  (param ('RESULT')) {
 $Result = param ('RESULT');
}

if  ( $Result eq 'EDIT_OBJ') {
 #edit button
param (-name=>'obj', -value=>param ('list_name')); #copy obj name from list
}

if  ($Result eq 'NEW_PAGE') {
my $pagename;
my $i=1;
my $pagefile;
do {
$pagename = 'page'.$i;
$pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
$i++;
}
while ( -e $pagefile);

#symulate edit page
param (-name=>'list_pages', -value=>$pagename);
$Result ='EDIT_PAGE';
}


print header (-expires=>'now',-charset=>$charset);


if (param ('NEW_NAME_OBJ')) {
#for create new object------------------------------------------------------------------

  $DefaultTemplate = 'ebadname.html';

  #create new object
  my $objname = param ('NEW_NAME_OBJ');
  my $objtype= param ('list_name');
  if ( ! defined ($objtype)) {
  $Tags {'ERROR'} = 'Please select graph category !!!';
  $DefaultTemplate ="error.html";
  } else {
  #test objname
   if ($objname =~ /^[a-z]\w+$/i)  {

   #test another objests
   my $objdir = $sysconfig {'OBJ_DIR'};
   my $exists =0;
   opendir (DIR, $objdir) || carp "Can't opendir $objdir: $! \n";
   my @objfiles = readdir (DIR);
   foreach (@objfiles) {
    if (/^([a-z]\w+)\.obj/) {
     #right filename
     if ($1 eq $objname) {
      $exists =1;
      last;
      }
    }
   }

 #test if DEMO version
 if (IF_DEMO ()) {
  $DefaultTemplate = 'demo.html';
 } else {

  if (! $exists) {
   #add to page
   if (param ('ADD_TO_PAGE')) {
    my $pagename = param ('page_name');
    check_page ($pagename);
   my $pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
   open (FILE,">>$pagefile") or croak "Cant write to $pagefile\n";
   print FILE "<P>\@\@\$$objname\@\@\n";
   close FILE;
   }
   #create object
   my $obj = CreateObjByClass ($objtype);
   $obj -> name ($objname);
   #fill default values
   $obj ->OnNew ();
   #save new object
   $obj ->Save;
   #send info for create
   SendMsg (2, $objname);
   #prepate to edit object
   param (-name=>'obj', -value=>$objname);
  }
 }
}
}
}


if (param ('EOPERATION')) {
 my $oper = param ('EOPERATION');
 if ($oper eq "EDIT_CONFIG") {
  my %userconfig2;
  OpenUserConfig (\%userconfig2); #open user config
  my $live_per = $userconfig2 {'LIVE_PERIOD'};
  foreach my $key (keys %userconfig2) {
   if (param ($key)) {
    #update key values
    $userconfig2 {$key} = param ($key);
   }
  }
      #convert for checkbox
 read_check_box (\%userconfig2, 'FORCE_IPCHAINS','LIVE_REFRESH','MORE_INFO','LOCK_LIVE' );
 $userconfig2 {'LANG'} = param ('lang_name');
 $userconfig2 {'SKIN'} = param ('skin_name');
 $userconfig2 {'PALETTE'} = param ('color_palette');
 #test it for security
 croak "Invalid language or skin.\n" if (($userconfig2 {'LANG'} =~ /\W/) or ($userconfig2 {'SKIN'} =~ /\W/));

 #test if DEMO version
 if (IF_DEMO ()) {
  $DefaultTemplate = 'demo.html';
 } else {
  SaveUserConfig (\%userconfig2);
  SendMsg (5, 0); #reload user config for lstatd
  Initialize_configs (); #initialize config files with new settings

  $DefaultTemplate = 'thanks.html';
 }
 }
} elsif (param ('obj')) {
#stats only for one objects

 my $Privobjname = param ('obj');
 $Tags {'OBJ_NAME'} = $Privobjname;

  #start new object for live
 my $obj = LoadObjectByName ($Privobjname); # load object to memory
 if (! defined ($obj)) { 
   $Tags {'ERROR'} = "Graph data expired. Try again.";
   Gen (\%Tags, 'error.html', 1);
 exit; 
 }
 #find name for temp object
 my $newname;
 my $objid;
 do {
  $objid = int (rand 100000);
  $newname = $sysconfig {'OBJ_DIR' }.$objid.'tmp.obj';
   } while (-e $newname );
 $obj->name ($objid.'tmp'); #set newname
 $obj->SaveToFile ($newname); #copy object
 $obj->Edit (\%Tags); #edit object
 undef $obj;
 exit;

} elsif (($Result eq 'OK_OBJ') or ($Result eq 'NEW_EL') or ($Result eq 'DEL_EL') or ($Result eq 'OK_EL')) {
#post edit object


 my $objname = param ('TEMP_OBJ_NAME');

 my $obj = LoadObjectByName ($objname); # load object to memory
 if (! defined ($obj)) { 
# croak "Can't load object: $objname \n" 
   $Tags {'ERROR'} = "Graph data expired. Try again.";
   Gen (\%Tags, 'error.html', 1);
 exit;
 }
 my @ParamNames = param();
 my %PostTags;
 foreach my $key (@ParamNames) {
  $PostTags {$key} =  param ($key);
 }
 $obj->PostEdit ( \%Tags, \%PostTags, 1); #save changes wirh display html page
 undef $obj;
 exit;
} elsif (($Result eq 'SAVE_EDIT') or ($Result eq 'CLOSE_EDIT') or ($Result eq 'RECREATE_EDIT')) {
#end edit object

 my $objname = param ('TEMP_OBJ_NAME');
 $Tags {'OBJ_NAME'} = param ('OBJ_NAME');
 $Tags {'TEMP_OBJ_NAME'} = param ('TEMP_OBJ_NAME');
 my $obj = LoadObjectByName ($objname); # load object to memory
 if (! defined ($obj)) { 
# croak "Can't load object: $objname \n" 
   $Tags {'ERROR'} = "Graph data expired. Try again.";
   Gen (\%Tags, 'error.html', 1);
 exit; 
 }
 
 my $hook = 0;
 $hook=2 if ($Result eq 'CLOSE_EDIT');
 $hook=1 if ($Result eq 'RECREATE_EDIT');

 if (($Result eq 'SAVE_EDIT') || ($hook==1)) {
 #post current data
 my @ParamNames = param();
 my %PostTags;
 foreach my $key (@ParamNames) {
  $PostTags {$key} =  param ($key);
 }
 $obj->PostEdit ( \%Tags, \%PostTags, 0); #save changes without displaying object's page
 }

 $obj->EndEdit ( \%Tags, $hook); #try end edit object
 undef $obj;
 exit;

}
 elsif ($Result eq 'CONFIRM_EDIT') {
#end edit object
 my $objname = param ('TEMP_OBJ_NAME');
 $Tags {'OBJ_NAME'} = param ('OBJ_NAME');
 $Tags {'TEMP_OBJ_NAME'} = param ('TEMP_OBJ_NAME');
 my $obj = LoadObjectByName ($objname); # load object to memory
 if (! defined ($obj)) { 
   $Tags {'ERROR'} = "Graph data expired. Try again.";
   Gen (\%Tags, 'error.html', 1);
 exit; 
 }
 $obj->EndEdit ( \%Tags,1); #finally end edit object
 undef $obj;
 exit;
}
 elsif ($Result eq 'NO_EDIT') {
#end edit object
 my $objname = param ('TEMP_OBJ_NAME');
 $Tags {'OBJ_NAME'} = param ('OBJ_NAME');
 $Tags {'TEMP_OBJ_NAME'} = param ('TEMP_OBJ_NAME');
 my $obj = LoadObjectByName ($objname); # load object to memory
 if (! defined ($obj)) { 
    $Tags {'ERROR'} = "Graph data expired. Try again.";
   Gen (\%Tags, 'error.html', 1);
 exit; 
 }
 $obj->EndEdit ( \%Tags,2); #drop edit object
 undef $obj;
 exit;
} elsif (param ('userconfig')) {
  $DefaultTemplate = 'econfig.html';
   #edit user config
   my %userconfig2;
   OpenUserConfig (\%userconfig2);
   while (my ($key, $value) = each %userconfig2 ) {
   $Tags {$key} = $value;
   }
   #convert for check box
   write_check_box  (\%Tags, 'FORCE_IPCHAINS','LIVE_REFRESH','MORE_INFO','LOCK_LIVE' );
   #generate language list
   $Tags {'LANG_TABLE'} = $valid_langs;
   my @langs = split (/,/,$valid_langs);
   my @langs_list = scrolling_list('lang_name',
                                       \@langs,
                                       $userconfig{'LANG'},1,'',
                                       \%dict);
   $Tags {'LANG_TABLE'} = \@langs_list;
   #palette
   my @color_list = scrolling_list('color_palette',
                                       ['color_std','color_pastel'],
                                       $userconfig{'PALETTE'},1,'',
                                       \%dict);
   $Tags {'COLOR_TABLE'} = \@color_list;
   #select skin
   my $skindir=$sysconfig{'TEMPLATE_DIR'}.'skins';
   #read all templates
   opendir (DIR, $skindir);
   my @skins = grep { /^\w/i } readdir (DIR);
   closedir DIR;
   my @skins_list = scrolling_list('skin_name',
                                       \@skins,
                                       $userconfig{'SKIN'},1,'',
                                       '');
   $Tags {'SKIN_TABLE'} = \@skins_list;

 }elsif ($Result eq 'NEW_OBJ') {
  #create page for new object
  $DefaultTemplate = 'eobject.html';

  my %ObjectTypes; #get all defined classes with description
  GetClassesNames (\%ObjectTypes);

  my @categories = keys %ObjectTypes;
  my @category_list = scrolling_list('list_name',\@categories,$categories[0],7,'',\%ObjectTypes);
  $Tags {'CATEGORY_LIST'} =  \@category_list;
  #create pages list
  my %labels;
  get_page_index (\%labels); #load pages descriptions
  my @pages = keys %labels;
  my @pages_list = scrolling_list('page_name',
                                       \@pages,
                                       $customname,1,'',
                                       \%labels);
  $Tags {'PAGES_LIST'} =  \@pages_list;
  }
  #process pages edit
  elsif ($Result eq 'EDIT_PAGE') {
  $DefaultTemplate = 'epageedit.html';
  my $pagename = param ('list_pages');
  check_page( $pagename);
  $Tags {'PAGE'} = $pagename;
  #search for page name
  my %labels;
  get_page_index (\%labels); #load pages descriptions
  $Tags {'PAGE_NAME'} = 'Bez nazwy';
  $Tags {'PAGE_NAME'} = $labels{$pagename} if (defined ($labels{$pagename}));
  #get page content
  my $pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
  my $content='';
    if (open (FILE, "<$pagefile") && (my @pgcontent=<FILE>) && (close FILE)) {
    $content = join ('',@pgcontent);
   }
  $Tags {'PAGE_CONTENT'} = [ textarea ('page_content', $content, 25, 80) ];
  }
  elsif ($Result eq 'OK_PAGE') {
  #post edit page
  $DefaultTemplate = 'thanks.html';
  my $pagename = param ('PAGE');
  check_page( $pagename);

  #test if DEMO version
 if (IF_DEMO ()) {
  $DefaultTemplate = 'demo.html';
 } else {

  my $pagedesc = param ('PAGE_NAME');
  my $pagecontent = param ('page_content');
   #search for page name
  my %labels;
  get_page_index (\%labels,1); #load pages descriptions without expand
  $labels {$pagename} = $pagedesc;
  #save page content
  my $pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
    if (open (FILE, ">$pagefile") && (print FILE $pagecontent) && (close FILE)) {
     #save page index
    my $indexfile=$sysconfig {'PAGE_INDEX'};
    if (open (FILE, ">$indexfile")) {
     foreach my $key (keys %labels) {
	print FILE "$key=",$labels{$key},"\n";
     }
     close FILE;
     }
   }
  }
  }
  elsif ($Result eq 'DEL_OBJ') {
   #remove object
   my $objname = param ('list_name');
   check_page ($objname);

 #test if DEMO version
 if (IF_DEMO ()) {
  $DefaultTemplate = 'demo.html';
 } else {

  #test if exists
  my $obj = LoadObjectByName ($objname); # load object to memory
  if (! defined ($obj)) { croak "Can't load object: $objname \n" }
  undef $obj;
  SendMsg (4, $objname); #send command for delete objects and his rrd.
  $Tags {'OBJ_NAME'} = $objname;
 $DefaultTemplate = 'askpage.html';
 }
  }
 elsif ($Result eq 'CONFIRM_SEARCH') {
 #delete all ocurrence object
 $DefaultTemplate = 'thanks.html';
 my $objname = param ('OBJ_NAME');
 check_page ($objname);
 #search among all pages
 my %pages;
 get_page_index (\%pages); #load pages descriptions
 my $pagefile;
 my @pgcontent;
 foreach my $pagename (keys %pages) {
  $pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
   if (open (FILE, "<$pagefile") && (my @pgcontent=<FILE>) && (close FILE)) {
    if ( grep /\@\@\$$objname\@\@/, @pgcontent) {
     #found reference to object
     my $filename2 = $pagefile.'.new';
     open (FILE, ">$filename2") or croak "Cant create $filename2: $!\n";
     foreach my $line (@pgcontent) {
     if (! ($line =~ /\@\@\$$objname\@\@/)) {print FILE $line}
     }
     close FILE;
     #delete and rename pagefile
     unlink ($pagefile);
     rename ($filename2, $pagefile);
     }
   }
 }

 }
 elsif ($Result eq 'DEL_PAGE') {
 #delete page
 my $pagename = param ('list_pages');
 check_page ($pagename);

#test if DEMO version
 if (IF_DEMO ()) {
  $DefaultTemplate = 'demo.html';
 } else {

 #search among all pages
 my %pages;
 get_page_index (\%pages,1); #load pages descriptions without expand
     #save new page index
    my $indexfile=$sysconfig {'PAGE_INDEX'};
    open (FILE, ">$indexfile")  or croak "Cant create index file $indexfile : $!";
     foreach my $key (keys %pages) {
	print FILE "$key=",$pages{$key},"\n" if ($key ne $pagename);
     }
     close FILE;

 my $pagefile=$sysconfig {'PAGE_DIR'}.$pagename;
 if (unlink ($pagefile)) {
 $DefaultTemplate = 'thanks.html';
 } else {croak "Error unlik file: $pagefile: $!"}
}
 }
 else { #default edit page
 my @Objects;
 LoadObjects (\@Objects); #load all objects in memory
 my @obj_name;
 #collect object names
 foreach my $obj (@Objects) {
  push (@obj_name, $obj->name ());
  #free object
  undef $obj;
 }
 if (@obj_name) {
 #generate obleci scroll list
  my @objlist = scrolling_list('list_name',
                                       [@obj_name],
                                       [$obj_name[0]],7);
  $Tags {'OBJ_LIST'} =  [@objlist ];
  } else  {$Tags {'OBJ_LIST'} =  ""}
 #generate page list
 $Tags {'PAGE_LIST'} =  "";
 my %labels;
 get_page_index (\%labels); #load pages descriptions
 my @pagesnames = keys %labels;
  my @pages_list = scrolling_list('list_pages',
                                       \@pagesnames,
                                       [$pagesnames[0]],7,'',
                                       \%labels);
 $Tags {'PAGE_LIST'} = [@pages_list];
  }


Gen (\%Tags,$DefaultTemplate,1);

#conver checkboxes to boolean, post
sub read_check_box {
 my $refhash = shift;
 if (@_ ) {
  foreach my $key (@_) {
   if (param($key)) {
    $refhash-> {$key} = 1;
    } else {$refhash->{$key} =0}
  }
 }
}

#conver checkboxes to boolean, prior edit
sub write_check_box {
 my $refhash = shift;
 if (@_ ) {
  foreach my $key (@_) {
   if ($refhash->{$key}) {
    $refhash-> {$key} = 'CHECKED';
    } else {$refhash->{$key} =''}
  }
 }
}

#test for valid page name
sub check_page {
 my $pagename=shift;
 croak "Invalid page name $pagename ." if (!($pagename =~ /^\w+$/));
}
